// Surf.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "..\TraceProDLL.h"
#include "Surf.h"

#include <math.h>
#include <stdlib.h>
#include <stdio.h>

// A tolerance for testing doubles approximately equal to zero apart from roundoff.
#define LF_ROUNDOFF_TOL	1.0e-14
#define SMALLANGLE		1.0e-6
#define	PI				3.14159265358979323846
#define TWOPI			6.28318530717958647692


BOOL APIENTRY DllMain( HANDLE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			random_function = NULL;
			break;
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


// random number function
double frand(void)
{
	if ( random_function == NULL )
		return 0.0;
	return (double)(random_function)();
}


// This initializes the DLL
SURF_API double fnInitDll(RAND_FN address)
{
	random_function = address;

	// TODO...
	// Add initialization code here.
	// This code will be called during the TracePro audit.

	return (double) 1.0;
}


////////////////////////////////////
// Start of example
////////////////////////////////////
SURF_API double fnEvaluateCoating(
								  double*	input,
								  int		input_size,
								  double*	user,
								  int		user_size,
								  double*	results,
								  int		results_size
								  )
{
	double result_val = 0;

	// zero-out the results array
	memset(results,0,sizeof(double)*results_size);
	results[SIGNAL_TO_TRACEPRO] = COATING_DLL_SIGNAL_NONE;

	double x = input[RAY_POS_X];
	double y = input[RAY_POS_Y];
	double r = sqrt( x*x + y*y );
	double rMax = 5.0;
	double tran = 1.0 - r/rMax;
	
	if( tran < 0.0 )
		tran = 0.0;

	results[TRAN_S] = results[TRAN_P] = tran;
	results[REFL_S] = results[REFL_P] = 1.0 - tran;

	return result_val;
}
////////////////////////////////////
// End of example
////////////////////////////////////
